package com.company;

import java.io.BufferedInputStream;
import java.util.*;

public class Vision {

    public static void main(String[] args) {
        Scanner input = new Scanner(new BufferedInputStream(System.in));
        int n = input.nextInt();
        Set<Pair> set=new TreeSet<>(new Comparator<Pair>() {
            @Override
            public int compare(Pair pair, Pair t1) {
                if(pair.x!=t1.x)
                    return pair.x-t1.x;
                return pair.y-t1.y;
            }
        });
        List<Pair> list=new ArrayList<>();

        for (int i = 0; i < n; i++) {
            Pair newPair=new Pair(input.nextInt(),input.nextInt());
            list.add(newPair);
            set.add(newPair);
        }

        Set<Pair> visited = new TreeSet<>(new Comparator<Pair>() {
            @Override
            public int compare(Pair pair, Pair t1) {
                if(pair.x!=t1.x)
                    return pair.x-t1.x;
                return pair.y-t1.y;
            }
        });
        int output = 0;
        for (int i = 1; i < n; i++) {
            Pair vector = list.get(i).diff( list.get(0));
            if(visited.contains(vector)||visited.contains(vector.inverse()))
                continue;
            output += 2;
            boolean finished = true;
            for(var x : list){
                if(!set.contains(x.diff(vector))&&!set.contains(x.diff(vector.inverse()))){
                    output -= 2;
                    finished = false;
                    break;

                }
            }
            if(finished){
                visited.add(vector);
            }

        }
        System.out.println(output);
    }


    static class Pair{
        int x;
        int y;

        public Pair(int x, int y) {
            this.x = x;
            this.y = y;
        }

        public Pair diff(Pair p){
            return new Pair(x-p.x,y-p.y);
        }

        public Pair inverse(){
            return new Pair(-x,-y);
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            Pair pair = (Pair) o;
            return x == pair.x &&
                    y == pair.y;
        }

        @Override
        public int hashCode() {
            return Objects.hash(x, y);
        }

        @Override
        public String toString() {
            return "Pair{" +
                    "x=" + x +
                    ", y=" + y +
                    '}';
        }
    }
}
